      PROGRAM    HEB_VIEW
! ************************************************************************
! *                                                                      *
! *   Program  HEB_VIEW  generates lat-lon plot of a variable defined in *
! *   in the input fiole in HEB format.                                  *
! *                                                                      *
! *  ### 23-MAY-2013    HEB_VIEW  v3.0 (c)  L. Petrov   15-MAY-2016 ###  *
! *                                                                      *
! ************************************************************************
      IMPLICIT   NONE 
      INCLUDE   'heb.i'
      TYPE     ( HEB__TYPE ) :: HEB, HEB_CL
      CHARACTER  FILHEB*128, FIL_COAST_LINE_HEB*128, FILOUT*128, STR*128, &
     &           STR1*128, TITLE*128, WORD1*16, WORD2*16, WORD3*16, WORD4*16, &
     &           WORD5*16, WORD6*16, REG*4
      REAL*4     LAT_MIN, LAT_MAX, LON_MIN, LON_MAX, VAL_MIN, VAL_MAX, SHIFT
      LOGICAL*1  LEX
      REAL*4     SCALE
      INTEGER*4  MIND
      PARAMETER  ( MIND = 32 )
      LOGICAL*1  FL_VIEW_LOOP
      INTEGER*8  LEN_MAX_I8
      PARAMETER  ( LEN_MAX_I8 = INT8(4)*INT8(1024)*INT8(1024)*INT8(1024) )
      INTEGER*4  IPAL, IPRC, IDEV, DIM3, IND3, IND4, IND(2,MIND), &
     &           LIND, LN, IND3_SECT(2), IND4_SECT(2), IUER
      INTEGER*4, EXTERNAL :: ILEN, I_LEN, READ_LINE 
      CHARACTER, EXTERNAL ::   MJDSEC_TO_DATE*30
!
      IND3 = 1
      IND4 = 1
      CALL CLRCH ( FILOUT )
      IF ( IARGC() == 1 ) THEN
           CALL GETARG ( 1, FILHEB )
           LAT_MIN = -90.0
           LAT_MAX =  90.0
           LON_MIN =   0.0
           LON_MAX = 360.0
           VAL_MIN =  0.0
           VAL_MAX = -10.0
           IPRC = 1
           IDEV = 1
           FILOUT = '/tmp/foo'
         ELSE IF ( IARGC() < 8 ) THEN
           WRITE ( 6, '(A)' ) 'heb_view filheb lat_min lat_max lon_min '// &
     &                        'lon_max val_min val_max iprc [filout] [ind3] [ind4]'
           CALL EXIT ( 1 )
         ELSE 
           CALL GETARG ( 1, FILHEB )
!
           CALL GETARG ( 2, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) LAT_MIN
!
           CALL GETARG ( 3, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) LAT_MAX
!
           CALL GETARG ( 4, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) LON_MIN
!
           CALL GETARG ( 5, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) LON_MAX
!
           CALL GETARG ( 6, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) VAL_MIN
!
           CALL GETARG ( 7, STR  )
           IF ( INDEX ( STR, '.' ) == 0 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR, FMT='(F10.5)' ) VAL_MAX
           CALL GETARG ( 8, STR    )
           CALL CHIN   ( STR, IPRC )
!
           IF ( IARGC() .GE. 9 ) THEN
                CALL GETARG ( 9, FILOUT )
                IF ( INDEX ( FILOUT, '.ps'  ) > 0 ) THEN
                     IDEV = 2
                     CALL CLRCH ( FILOUT(ILEN(FILOUT)-2:) )
                  ELSE IF ( INDEX ( FILOUT, '.eps'  ) > 0 ) THEN
                     IDEV = 2
                     CALL CLRCH ( FILOUT(ILEN(FILOUT)-3:) )
                  ELSE IF ( INDEX ( FILOUT, '.gif' ) > 0 ) THEN
                     IDEV = 3
                     CALL CLRCH ( FILOUT(ILEN(FILOUT)-3:) )
                  ELSE IF ( FILOUT == 'XW' .OR. FILOUT == '/XW' .OR. &
     &                      FILOUT == 'xw' .OR. FILOUT == '/xw'      ) THEN
                     IDEV = 1
                     FILOUT = '/tmp/foo'
                  ELSE 
                     IUER = -2
                     CALL ERR_LOG ( 6701, IUER, 'HEB_VIEW', 'Output '// &
     &                   'file should have extension .ps or .gif' )
                     CALL EXIT ( 1 )
                END IF
              ELSE 
                IDEV = 1
                FILOUT = '/tmp/foo'
           END IF
!
           IF ( IARGC() .GE. 10 ) THEN
                CALL GETARG ( 10, STR )
                CALL CHIN ( STR, IND3 )
                IF ( IND3 < 1 ) IND3 = 1
           END IF
!
           IF ( IARGC() .GE. 11 ) THEN
                CALL GETARG ( 11, STR )
                CALL CHIN ( STR, IND4 )
                IF ( IND4 < 1 ) IND4 = 1
           END IF
      END IF
!
      INQUIRE ( FILE=FILHEB, EXIST=LEX )
      IF ( .NOT. LEX ) THEN
           IUER = -2
           CALL ERR_LOG ( 6702, IUER, 'HEB_VIEW', 'Input file '// &
     &          FILHEB(1:I_LEN(FILHEB))//' is not found' )
           CALL EXIT ( 1 )
      END IF
      IF ( LAT_MIN < -90.0 ) THEN
           IUER = -2
           CALL GETARG ( 2, STR )
           CALL ERR_LOG ( 6703, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lat_min: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'less than -90.0' )
           CALL EXIT ( 1 )
      END IF 
      IF ( LAT_MAX >  90.0 ) THEN
           IUER = -2
           CALL GETARG ( 3, STR )
           CALL ERR_LOG ( 6704, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lat_max: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'greater than 90.0' )
           CALL EXIT ( 1 )
      END IF 
      IF ( LAT_MIN .GE. LAT_MAX ) THEN
           IUER = -2
           CALL GETARG ( 2, STR )
           CALL GETARG ( 3, STR1 )
           CALL ERR_LOG ( 6705, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lat_min: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'greater than lat_max '//STR1 )
           CALL EXIT ( 1 )
      END IF 
      IF ( LON_MIN < -180.0 ) THEN
           IUER = -2
           CALL GETARG ( 4, STR )
           CALL ERR_LOG ( 6706, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lat_min: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'less than -180.0' )
           CALL EXIT ( 1 )
      END IF 
      IF ( LON_MAX > 360.0 ) THEN
           IUER = -2
           CALL GETARG ( 5, STR )
           CALL ERR_LOG ( 6707, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lat_max: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'greater than 360.0' )
           CALL EXIT ( 1 )
      END IF 
      IF ( LON_MIN .GE. LON_MAX ) THEN
           IUER = -2
           CALL GETARG ( 4, STR )
           CALL GETARG ( 5, STR1 )
           CALL ERR_LOG ( 6708, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lon_min: '//STR(1:I_LEN(STR))//' -- it should not be '// &
     &         'greater than lon_max '//STR1 )
           CALL EXIT ( 1 )
      END IF 
      IF ( LON_MAX - LON_MIN > 360.0 ) THEN
           IUER = -2
           CALL GETARG ( 4, STR )
           CALL GETARG ( 5, STR1 )
           CALL ERR_LOG ( 6709, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'lon_min: '//STR(1:I_LEN(STR))//' -- the difference wrt '// &
     &         'lon_max '//STR1(1:I_LEN(STR1))//' should not exceed '// &
     &         '360.0 degrees' )
           CALL EXIT ( 1 )
      END IF 
      IF ( IPRC .NE. 1  .AND.  IPRC .NE. 2  .AND.  &
     &     IPRC .NE. -2 .AND.  IPRC .NE. 3  .AND.  IPRC .NE. 4 ) THEN
           IUER = -2
           CALL GETARG  ( 8, STR )
           CALL ERR_LOG ( 6710, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'IPRC: '//STR(1:I_LEN(STR))//' -- only values 1 or 2, -2, or 3'// &
     &         ' are supported' )
           CALL EXIT ( 1 )
      END IF 
      CALL GETENVAR ( 'MALO_PLOT_SHIFT', STR )
!
      IUER = -1
      CALL READ_HEB_HEADER ( FILHEB, HEB, IUER )
      IF ( IUER .NE. 0 ) THEN
           IUER = -2
           CALL ERR_LOG ( 6711, IUER, 'HEB_VIEW', 'Error in reading '// &
     &         'input heb-file '//FILHEB )
           CALL EXIT ( 1 )
      END IF 
!
      IF ( IND3 > HEB%DIMS(3) ) THEN
           IUER = -2
           CALL CLRCH ( STR )
           CALL CLRCH ( STR1 )
           CALL INCH  ( IND3, STR1 )
           CALL INCH8 ( HEB%DIMS(3), STR1 )
           CALL ERR_LOG ( 6712, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'IND3: '//STR(1:I_LEN(STR))//' it is greater than '// &
     &         'DIMS(3): '//STR1(1:I_LEN(STR1))//' of the '// &
     &         'input heb-file '//FILHEB )
           CALL EXIT ( 1 )
      END IF
!
      IF ( IND4 > HEB%DIMS(4) ) THEN
           IUER = -2
           CALL CLRCH ( STR )
           CALL CLRCH ( STR1 )
           CALL INCH  ( IND4, STR1 )
           CALL INCH8 ( HEB%DIMS(3), STR1 )
           CALL ERR_LOG ( 6713, IUER, 'HEB_VIEW', 'Wrong parameter '// &
     &         'IND4: '//STR(1:I_LEN(STR))//' it is greater than '// &
     &         'DIMS(4): '//STR1(1:I_LEN(STR1))//' of the '// &
     &         'input heb-file '//FILHEB )
           CALL EXIT ( 1 )
      END IF
!
      IF ( HEB%DIMS(1)*HEB%DIMS(2)*HEB%DIMS(3)*HEB%DIMS(4) < LEN_MAX_I8 ) THEN
           IUER = -1
           CALL READ_HEB ( FILHEB, HEB, IUER )
           IF ( IUER .NE. 0 ) THEN
                IUER = -2
                CALL ERR_LOG ( 6714, IUER, 'HEB_VIEW', 'Error in reading '// &
     &              'input heb-file '//FILHEB )
                CALL EXIT ( 1 )
           END IF 
         ELSE
           IND3_SECT(1) = IND3
           IND3_SECT(2) = IND3
           IND4_SECT(1) = IND4
           IND4_SECT(2) = IND4
           IUER = -1
           CALL READ_HEB_SECT ( FILHEB, HEB, IND3_SECT, IND4_SECT, IUER )
           IF ( IUER .NE. 0 ) THEN
                IUER = -2
                CALL ERR_LOG ( 6715, IUER, 'HEB_VIEW', 'Error in reading '// &
     &              'input heb-file '//FILHEB )
                CALL EXIT ( 1 )
           END IF 
           CALL GETENVAR ( 'HEB_VIEW_AMPL', STR1 )
           IF ( STR1 == 'YES' .OR. STR1  == 'yes' ) THEN
                CALL READ_HEB_SECT ( FILHEB, HEB_CL, IND3_SECT, IND4_SECT+1, IUER )
                HEB%VAL(1:HEB%DIMS(1),1:HEB%DIMS(2),1,1) = SQRT ( HEB%VAL(1:HEB%DIMS(1),1:HEB%DIMS(2),1,1)**2 + &
     &                                                            HEB_CL%VAL(1:HEB%DIMS(1),1:HEB%DIMS(2),1,1)**2   )
           END IF
           IND3 = 1
           IND4 = 1
      END IF 
      IF ( ILEN(STR) > 0 ) THEN
           IF ( INDEX ( STR, '.' ) < 1 ) STR = STR(1:I_LEN(STR))//'.'
           READ ( UNIT=STR(1:I_LEN(STR)), FMT='(F10.5)' ) SHIFT
           HEB%VAL = HEB%VAL + SHIFT
           VAL_MIN = MINVAL ( HEB%VAL )
           VAL_MAX = MAXVAL ( HEB%VAL )
      END IF
      IF ( VAL_MIN .GE. VAL_MAX ) THEN
           VAL_MIN = HEB%MIN_VALUE
           VAL_MAX = HEB%MAX_VALUE
      END IF
      CALL GETENVAR ( 'HEB_VIEW_COAST_LINE', FIL_COAST_LINE_HEB )
      IF ( ILEN(FIL_COAST_LINE_HEB) > 0 ) THEN
           CALL READ_HEB ( FIL_COAST_LINE_HEB, HEB_CL, IUER )
      END IF
!
      IPAL = 7
      IUER = -1
      IUER = -1
      CALL GETENVAR ( 'HEB_VIEW_SCALE', STR )
      IF ( ILEN(STR) > 0 .AND. ASSOCIATED ( HEB%VAL) ) THEN
           READ ( UNIT=STR, FMT='(F10.5)' ) SCALE
           HEB%VAL = SCALE*HEB%VAL
           VAL_MIN = SCALE*VAL_MIN
           VAL_MAX = SCALE*VAL_MAX
      END IF 
      CALL GETENVAR ( 'HEB_VIEW_LOOP', STR )
      IF ( STR == 'NO' ) THEN
           FL_VIEW_LOOP = .FALSE.
         ELSE 
           FL_VIEW_LOOP = .TRUE.
      END IF 
      STR = MJDSEC_TO_DATE ( HEB%MJD, HEB%UTC, IUER )
      TITLE = HEB%TITLE(1:I_LEN(HEB%TITLE))//' at '//STR(1:16)
 710  CONTINUE 
      IF ( IPRC .EQ. 1 .OR. IPRC == 2 ) THEN
           IF ( HEB%DATA_FORMAT    == HEB__I1   .AND. &
     &          HEB%DATA_TRANSFORM == HEB__NONE       ) THEN
                CALL PLOT_REGION_R1 ( IDEV, IPAL, IPRC, INT(HEB%DIMS(1),KIND=4),  &
     &                                                  INT(HEB%DIMS(2),KIND=4),  &
     &                                HEB%VAL1(1,1,IND3,IND4), TITLE,  HEB%UNITS, &
     &                                FILOUT, LON_MIN, LON_MAX, LAT_MIN, LAT_MAX, &
     &                                VAL_MIN, VAL_MAX, IUER )
              ELSE
                IF ( HEB%DATA_FORMAT == HEB__R8 .AND. ASSOCIATED ( HEB%VAL8 ) ) THEN
                     ALLOCATE ( HEB%VAL(HEB%DIMS(1),HEB%DIMS(2),HEB%DIMS(3),HEB%DIMS(4)), &
     &                          STAT=IUER )
                     IF ( IUER .NE. 0 ) THEN
                          CALL CLRCH ( STR )
                          CALL IINCH8 ( INT8(4)*HEB%DIMS(1)*HEB%DIMS(2)*HEB%DIMS(3)*HEB%DIMS(4), STR )
                          IUER = -2
                          CALL ERR_LOG ( 6716, IUER, 'HEB_VIEW', 'Failure to allocate '// &
     &                         STR(1:I_LEN(STR))//' bytes of dynamic memory for array '// &
     &                         'HEB_OUT%VAL4' )
                          CALL EXIT ( 1 )
                     END IF 
                     CALL SPD_R8_TO_R4 ( HEB%DIMS(1)*HEB%DIMS(2)*HEB%DIMS(3)*HEB%DIMS(4), HEB%VAL8, HEB%VAL )
                     DEALLOCATE ( HEB%VAL8 )
                END IF 
!
                IF ( ILEN(FIL_COAST_LINE_HEB) == 0 ) THEN
                     CALL PLOT_REGION_R4 ( IDEV, IPAL, IPRC, INT(HEB%DIMS(1),KIND=4),  &
     &                                                       INT(HEB%DIMS(2),KIND=4),  &
     &                                     HEB%VAL(1,1,IND3,IND4), TITLE,  HEB%UNITS,  &
     &                                     FILOUT, LON_MIN, LON_MAX, LAT_MIN, LAT_MAX, &
     &                                     VAL_MIN, VAL_MAX, IUER )
                   ELSE
                     CALL PLOT_REGION_COA_R4 ( IDEV, IPAL, IPRC, 0, &
     &                                         INT(HEB%DIMS(1),KIND=4),  &
     &                                         INT(HEB%DIMS(2),KIND=4),  &
     &                                         HEB%VAL(1,1,IND3,IND4), HEB_CL%VAL(1,1,IND3,IND4), %VAL(0), &
     &                                         TITLE,  HEB%UNITS, FILOUT, &
     &                                         LON_MIN, LON_MAX, LAT_MIN, LAT_MAX, &
     &                                         VAL_MIN, VAL_MAX, IUER )
                END IF
           END IF
         ELSE IF ( IPRC == 3 .OR. IPRC == 4 ) THEN
!!         TITLE = 'Geoid undulations'
           IF ( HEB%DATA_FORMAT == HEB__I1 ) THEN
                ALLOCATE (   HEB%VAL(HEB%DIMS(1),HEB%DIMS(2),HEB%DIMS(3),HEB%DIMS(4)) )
                HEB%VAL = HEB%VAL1
                DEALLOCATE ( HEB%VAL1 )
             ELSE IF ( HEB%DATA_FORMAT == HEB__I2 ) THEN
                ALLOCATE (   HEB%VAL(HEB%DIMS(1),HEB%DIMS(2),HEB%DIMS(3),HEB%DIMS(4)) )
                HEB%VAL = HEB%VAL2
                DEALLOCATE ( HEB%VAL2 )
           END IF
           CALL PLOT_GRID_R4 ( IDEV, IPAL, 0, IPRC, &
     &                         INT(HEB%DIMS(1),KIND=4), INT(HEB%DIMS(2),KIND=4), &
     &                         HEB%VAL(1,1,IND3,IND4), TITLE, HEB%UNITS, &
     &                         VAL_MIN, VAL_MAX, FILOUT, IUER )
      END IF
      IF ( IUER .NE. 0 ) THEN
           IUER = -2
           CALL ERR_LOG ( 6717, IUER, 'HEB_VIEW', 'Error in an attempt '// &
     &         'to generate a plot' )
           CALL EXIT ( 1 )
      END IF 
      IF ( IDEV == 1 .AND. FL_VIEW_LOOP ) THEN
 720       CONTINUE 
           LN = READ_LINE ( 'Enter new lat_min lat_max  lon_min lon_max >>', STR )
           REG = CHAR(32)//CHAR(0)//CHAR(9)//','
           CALL EXWORD ( STR, MIND, LIND, IND, REG, IUER )
           IF ( LIND < 4 ) THEN
                WRITE ( 6, * ) 'Too few words: ', LIND
                GOTO 720
           END IF
!
           WORD1 = STR(IND(1,1):IND(2,1))
           IF ( INDEX ( WORD1, '.' ) == 0 ) WORD1 = WORD1(1:I_LEN(WORD1))//'.'
           READ ( UNIT=WORD1, FMT='(F15.7)', IOSTAT=IUER ) LAT_MIN
           IF ( IUER .NE. 0 ) THEN
                WRITE ( 6, * ) 'Wrong lat_min'
                GOTO 720
           END IF
!         
           WORD2 = STR(IND(1,2):IND(2,2))
           IF ( INDEX ( WORD2, '.' ) == 0 ) WORD2 = WORD2(1:I_LEN(WORD2))//'.'
           READ ( UNIT=WORD2, FMT='(F15.7)', IOSTAT=IUER ) LAT_MAX
           IF ( IUER .NE. 0 ) THEN
                WRITE ( 6, * ) 'Wrong lat_max'
                GOTO 720
           END IF
!
           WORD3 = STR(IND(1,3):IND(2,3))
           IF ( INDEX ( WORD3, '.' ) == 0 ) WORD3 = WORD3(1:I_LEN(WORD3))//'.'
           READ ( UNIT=WORD3, FMT='(F15.7)', IOSTAT=IUER ) LON_MIN
           IF ( IUER .NE. 0 ) THEN
                WRITE ( 6, * ) 'Wrong lon_min'
                GOTO 720
           END IF
!
           WORD4 = STR(IND(1,4):IND(2,4))
           IF ( INDEX ( WORD4, '.' ) == 0 ) WORD4 = WORD4(1:I_LEN(WORD4))//'.'
           READ ( UNIT=WORD4, FMT='(F15.7)', IOSTAT=IUER ) LON_MAX
           IF ( IUER .NE. 0 ) THEN
                WRITE ( 6, * ) 'Wrong lon_max'
                GOTO 720
           END IF
!
           IF ( LIND .GE. 5 ) THEN
                WORD5 = STR(IND(1,5):IND(2,5))
                IF ( INDEX ( WORD5, '.' ) == 0 ) WORD5 = WORD5(1:I_LEN(WORD5))//'.'
                READ ( UNIT=WORD5, FMT='(F15.7)', IOSTAT=IUER ) VAL_MIN
                IF ( IUER .NE. 0 ) THEN
                     WRITE ( 6, * ) 'Wrong val_min'
                     GOTO 720
                END IF
           END IF
!
           IF ( LIND .GE. 6 ) THEN
                WORD6 = STR(IND(1,6):IND(2,6))
                IF ( INDEX ( WORD6, '.' ) == 0 ) WORD6 = WORD6(1:I_LEN(WORD6))//'.'
                READ ( UNIT=WORD6, FMT='(F15.7)', IOSTAT=IUER ) VAL_MAX
                IF ( IUER .NE. 0 ) THEN
                     WRITE ( 6, * ) 'Wrong val_max'
                     GOTO 720
                END IF
           END IF
           GOTO 710
      END IF
      END  PROGRAM  HEB_VIEW  !#!#
